/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','./Matcher','./Visible','sap/ui/test/launchers/iFrameLauncher'],function($,M,V,f){"use strict";var v=new V();return M.extend("sap.ui.test.matchers.Interactable",{isMatching:function(c){var h=f._getAutoWaiter().hasToWait();if(h){return false;}var b=v.isMatching(c);if(!b){return false;}if(c.getBusy&&c.getBusy()){this._oLogger.debug("The control "+c+" is busy so it is filtered out");return false;}if(c.getEnabled&&!c.getEnabled()){this._oLogger.debug("The control '"+c+"' is not enabled");return false;}var p=c.getParent();while(p){if(p.getBusy&&p.getBusy()){this._oLogger.debug("The control "+c+" has a parent that is busy "+p);return false;}if(p.getEnabled&&!p.getEnabled()){this._oLogger.debug("The control '"+c+"' has a parent '"+p+"' that is not enabled");return false;}var n=p.getMetadata().getName();if(n==="sap.ui.core.UIArea"&&p.bNeedsRerendering){this._oLogger.debug("The control "+c+" is currently in an ui area that needs a new rendering");return false;}p=p.getParent();}if(c.$().closest("#sap-ui-static").length===0){if($("#sap-ui-blocklayer-popup").is(":visible")){this._oLogger.debug("The control "+c+" is hidden behind a blocking layer of a Popup");return false;}}return true;}});},true);
